# Deepvue Aadhaar Offline e-KYC Flutter SDK
Aadhaar Paperless Offline eKYC is a secure and shareable document which can be used by any Aadhaar holder for offline verification of identification. The Aadhaar Offline document can be obtained from the UIDAI website. This SDK provides a simple plugin to your mobile App which allows the user to seamlessly share their offline Aadhaar file with the service provider.

The Aadhaar Offline file will be validated for its digital signature and the KYC data of The Aadhaar holder will be passed to the integrating App as JSON data.


# Table Of Content

- [Prerequisite](#prerequisite)
- [Setup](#setup)
- [Usage](#usage)
- [Failure Status Codes](#failure-status-codes)
- [Help](#help)

## Prerequisite

You will need valid credentials to use the Deepvue Aadhaar Offline e-KYC React Native SDK, which can be obtained by contacting `hello@deepvue.tech`

## Setup
```
# add this line to your dependencies
aadhaar_offline_ekyc: ^0.0.3
```
## Usage
```
   OfflineAadhaarSdk(
      baseUrl: 'https://production.deepvue.tech/v1',
      clientId: 'your-client-id',
      clientSecret: 'your-client-secret',
      useFaceMatch: true/false,
      imageUrl: image-url-for-first-screen, # leave this empty for deepvue default image on first screen
      failureCallback: (int failureCode) {

      },
      successCallback: (String response) {

      },
    );
```
## Failure Status Codes
Following error codes will be returned on the `onFailure` method of the callback

| CODE | DESCRIPTION                  |
| ---- | ---------------------------- |
| 801  | SDK Invalid Credentials      |
| 802  | Permission Denied            |
| 803  | User Interrupted             |
| 804  | No Internet Available        |
| 805  | Network Error                |
| 806  | OTP Limit Exceeded       |
| 807  | Mobile Number Not Linked to Aadhaar             |
| 808  | File Download Failed
| 809  | File Upload Failed |
| 810  | Face Match Failed            |
| 404  | UIDAI Website Server Down            |


## Help
For any queries/feedback, contact us at `hello@deepvue.tech` 
