import 'dart:convert';

class AadhaarModel {
  AadhaarModel({
    required this.aadhaar,
    this.facematch,
  });

  Aadhaar aadhaar;
  Facematch? facematch;

  factory AadhaarModel.fromRawJson(String str) =>
      AadhaarModel.fromJson(json.decode(str));

  String toRawJson() => json.encode(toJson());

  factory AadhaarModel.fromJson(Map<String, dynamic> json) => AadhaarModel(
        aadhaar: Aadhaar.fromJson(json["aadhaar"]),
        facematch: json.containsKey("facematch")
            ? Facematch.fromJson(json["facematch"])
            : null,
      );

  String displayModel() {
    if (facematch != null) {
      return "Generated At: ${aadhaar.generatedAt}\n"
          "Masked Number: ${aadhaar.maskedNumber}\n"
          "Name: ${aadhaar.name}\n"
          "Gender: ${aadhaar.gender}\n\n"
          "FaceMatch: ${facematch!.match}\n"
          "Confidence: ${facematch!.confidence}\n";
    } else {
      return "Generated At: ${aadhaar.generatedAt}\n"
          "Masked Number: ${aadhaar.maskedNumber}\n"
          "Name: ${aadhaar.name}\n"
          "Gender: ${aadhaar.gender}\n";
    }
  }

  Map<String, dynamic> toJson() => {
        "aadhaar": aadhaar.toJson(),
        "facematch": facematch?.toJson(),
      };
}

class Aadhaar {
  Aadhaar({
    required this.address,
    required this.dateOfBirth,
    required this.email,
    required this.gender,
    required this.generatedAt,
    required this.maskedNumber,
    required this.name,
    required this.phone,
    required this.photo,
  });

  Address address;
  String dateOfBirth;
  String email;
  String gender;
  String generatedAt;
  String maskedNumber;
  String name;
  String phone;
  String photo;

  factory Aadhaar.fromRawJson(String str) => Aadhaar.fromJson(json.decode(str));

  String toRawJson() => json.encode(toJson());

  factory Aadhaar.fromJson(Map<String, dynamic> json) => Aadhaar(
        address: Address.fromJson(json["address"]),
        dateOfBirth: json["dateOfBirth"],
        email: json["email"],
        gender: json["gender"],
        generatedAt: json["generatedAt"],
        maskedNumber: json["maskedNumber"],
        name: json["name"],
        phone: json["phone"],
        photo: json["photo"],
      );

  Map<String, dynamic> toJson() => {
        "address": address.toJson(),
        "dateOfBirth": dateOfBirth,
        "email": email,
        "gender": gender,
        "generatedAt": generatedAt,
        "maskedNumber": maskedNumber,
        "name": name,
        "phone": phone,
        "photo": photo,
      };
}

class Address {
  Address({
    required this.careOf,
    required this.country,
    required this.district,
    required this.house,
    required this.landmark,
    required this.locality,
    required this.pin,
    required this.postOffice,
    required this.state,
    required this.street,
    required this.subDistrict,
    required this.vtc,
  });

  String careOf;
  String country;
  String district;
  String house;
  String landmark;
  String locality;
  String pin;
  String postOffice;
  String state;
  String street;
  String subDistrict;
  String vtc;

  factory Address.fromRawJson(String str) => Address.fromJson(json.decode(str));

  String toRawJson() => json.encode(toJson());

  factory Address.fromJson(Map<String, dynamic> json) => Address(
        careOf: json["careOf"],
        country: json["country"],
        district: json["district"],
        house: json["house"],
        landmark: json["landmark"],
        locality: json["locality"],
        pin: json["pin"],
        postOffice: json["postOffice"],
        state: json["state"],
        street: json["street"],
        subDistrict: json["subDistrict"],
        vtc: json["vtc"],
      );

  Map<String, dynamic> toJson() => {
        "careOf": careOf,
        "country": country,
        "district": district,
        "house": house,
        "landmark": landmark,
        "locality": locality,
        "pin": pin,
        "postOffice": postOffice,
        "state": state,
        "street": street,
        "subDistrict": subDistrict,
        "vtc": vtc,
      };
}

class Facematch {
  Facematch({
    required this.match,
    required this.confidence,
  });

  bool match;
  int confidence;

  factory Facematch.fromRawJson(String str) =>
      Facematch.fromJson(json.decode(str));

  String toRawJson() => json.encode(toJson());

  factory Facematch.fromJson(Map<String, dynamic> json) => Facematch(
        match: json["match"],
        confidence: json["confidence"],
      );

  Map<String, dynamic> toJson() => {
        "match": match,
        "confidence": confidence,
      };
}
