import 'package:equatable/equatable.dart';

abstract class Failure extends Equatable {
  final String message;

  const Failure(this.message);

  @override
  List<Object> get props => [message];
}

// General failures
class ServerFailure extends Failure {
  const ServerFailure(String message, int errorCode) : super(message);
}

class NetworkFailure extends Failure {
  static const String msg = "Some problem with your internet connectivity";

  const NetworkFailure() : super(msg);
}

class DataFailure extends Failure {
  const DataFailure(String message) : super(message);
}
