import 'package:aadhaar_offline_ekyc/api/api_service.dart';
import 'package:aadhaar_offline_ekyc/controllers/aadhaar_sdk_controller.dart';
import 'package:aadhaar_offline_ekyc/utils/toast_util.dart';
import 'package:aadhaar_offline_ekyc/utils/utils.dart';
import 'package:get/get.dart';

class FirstController extends GetxController {
  final ApiService _apiService;
  final AadhaarSdkController _aadhaarSdkController;
  var loader = false.obs;

  FirstController(
    this._apiService,
    this._aadhaarSdkController,
  );

  @override
  void onReady() {
    authorize();
    super.onReady();
  }

  void authorize() async {
    loader.value = true;
    var response = await _apiService.authorize(
        _aadhaarSdkController.clientId, _aadhaarSdkController.clientSecret);
    return response.fold((l) {
      loader.value = false;
      if (l.message.toLowerCase().contains("host")) {
        showToast(
          "No Internet Available",
          callback: () {
            _aadhaarSdkController.failureCallback(804);
          },
        );

        closeSdk();
      } else {
        showToast(
          l.message,
          callback: () {
            closeSdk();
          },
        );
      }
    }, (r) {
      loader.value = false;
    });
  }
}
